/* Funkbots 1.15: Copyright 1998  Jonathan Sharkey. Please read reame.txt
for important info */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <values.h>
#include <time.h>
#include <math.h>
#include <allegro.h>
#include "grabber.h"

#define ISHORT signed short int

#define NORMAL  0
#define POWER   1
#define SEEKS   2
#define PSEEK   3
#define MINES   4
#define PMINE   5
#define ENERGY1 6
#define ENERGY2 7
#define ENERGY5 8

#define NONE  0
#define GREC  1
#define REC   2
#define GPLAY 3
#define PLAY  4

/* MAIN.C */
void init(void);
void do_titlescreen(void);
void quit(void);

/* SETUP.C */
void   load_battle_file(char *, char *);
void   load_robot(char *, char *);
int    code_size(char *);
ISHORT format_string(char *);
char  *get_command(char *, char *);
void   load_code(char *);
int    randnum(int);
void   setup_movie(char *);

/* BATTLE.C */
void do_battle(void);
void counter(void);
void draw_stats(void);
void draw_screen(void);
void do_items(void);
void do_shots(void);
void do_expls(void);

/* ROBOTS.C */
void do_robots(void);
ISHORT read_byte(void);
float read_value(void);
void start_shot(void);
ISHORT calc_x(ISHORT);
ISHORT calc_y(ISHORT);
void do_if(void);
void skip_else_code(void);

struct var_struct {
  ISHORT game_speed;
  ISHORT total_robots;
  ISHORT robots_alive;
  ISHORT robot_energy;
  ISHORT total_items;
  ISHORT total_expls;
  ISHORT total_shots;
  ISHORT item_delay;
  ISHORT item_count;
  ISHORT num_covers;
  ISHORT num_item[9];
  ISHORT item_chance[9];
  ISHORT chance[300];
  ISHORT num_chance;
  ISHORT video;
  ISHORT sound;
  ISHORT movie_s;
  PACKFILE *movie_f;
  char   movie_name[13];
  ISHORT res_x;
  ISHORT res_y;
  ISHORT area_x;
  ISHORT area_y;
  ISHORT x1, x2, y1, y2;
  ISHORT pos_x, pos_y;
};

struct robot_struct {
  char   name[14];
  ISHORT user_ctrl;
  ISHORT x;
  ISHORT y;
  float data[1000];
  ISHORT energy;
  ISHORT ammo[6];
  ISHORT alive;
  ISHORT shot_count;
  ISHORT total_hits;
  ISHORT hits[256];
  ISHORT kills;
  float debug;
  int code_size;
  ISHORT *code;
  BITMAP *image;
};

struct item_struct {
  ISHORT type;
  ISHORT x;
  ISHORT y;
};

struct shot_struct {
  ISHORT type;
  int x;
  int y;
  ISHORT speed_x;
  ISHORT speed_y;
  ISHORT robot;
  ISHORT count;
};

struct expl_struct {
  ISHORT robot;
  ISHORT x;
  ISHORT y;
  ISHORT frame;
};

struct cover_it_struct {
  ISHORT x;
  ISHORT y;
  ISHORT x_size;
  ISHORT y_size;
};

extern struct var_struct var;
extern struct robot_struct robot[256];
extern struct item_struct item[256];
extern struct shot_struct shot[1000];
extern struct expl_struct expl[1000];
extern struct cover_it_struct cover_it[1000];

extern DATAFILE *gamedata;
extern BITMAP *bat_scr;
